您的位置:首页 > 其它

HDU-2955-Robberies【01背包】

2016-01-25 13:48 323 查看

HDU-2955-Robberies

[code]    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)


Problem Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .

Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints

0 < T <= 100

0.0 <= P <= 1.0

0 < N <= 100

0 < Mj <= 100

0.0 <= Pj <= 1.0

A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input

3

0.04 3

1 0.02

2 0.03

3 0.05

0.06 3

2 0.03

2 0.03

3 0.05

0.10 3

1 0.03

2 0.02

3 0.05

Sample Output

2

4

6

题目链接:HDU-2955

题目大意:有一个小偷Roy,有n个银行,每家银行都有一定的金额和被抓到的概率,知道Roy被抓的最大概率P,求Roy在不被抓的情况下,抢劫最多。

题目思路:直接01背包会比较麻烦,因为被抓概率是一个浮点数。所以把问题转化成安全的概率。

[code]状态转移方程:dp[j] = max(dp[j - m[i]] * (1 - p[i]),dp[j]); //抢了第i个银行不被抓的概率,和不抢


以下是代码:

[code]#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <string>
#include <cstring>
using namespace std;
int m[200];
double p[200];
double dp[10050]; //偷了j的钱,不被抓的最大概率
int main(){
    int T;
    cin >> T;
    while(T--)
    {
        memset(dp,0,sizeof(dp));
        double P;
        int n;
        cin >> P >> n;
        int total = 0; //记录总额 
        for (int i = 1; i <= n; i++)
        {
            cin >> m[i] >> p[i];
            total += m[i];
        }
        dp[0] = 1; //不偷钱,不被抓的概率肯定为1;
        for (int i = 1; i <= n; i++)    
        {
            for(int j = total; j >= m[i]; j--) //偷了的金额 
            {
                dp[j] = max(dp[j - m[i]] * (1 - p[i]),dp[j]); //抢了第i个还不被抓的概率,和不取第i个。 
            } 
        } 

        for (int i = total; i >= 0; i--)
        {
            if (dp[i] >= (1 - P))
            {
                cout << i << endl;
                break;
            } 
        }
    }
    return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: